"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_element_1 = require("./abstract-element");
exports.AbstractElement = abstract_element_1.AbstractElement;
function Define(nameTag) {
    return function (originalConstructor) {
        try {
            customElements.define(nameTag, originalConstructor);
        }
        catch (error) {
            console.warn(error);
        }
    };
}
exports.Define = Define;
function state() {
    return function (target, key, descriptor) {
        makePropertyMapper(target, key, function (value) { return value; }, descriptor);
    };
}
exports.state = state;
function makePropertyMapper(prototype, key, mapper, descriptor) {
    if (descriptor) {
        var setter_1 = descriptor.set || function () { };
        descriptor.set = function (val) {
            setter_1.apply(this, [val]);
            this.forceUpdate();
        };
    }
    else {
        var values_1 = new Map();
        Reflect.defineProperty(prototype, key, {
            set: function (firstValue) {
                Reflect.defineProperty(this, key, {
                    get: function () {
                        return values_1.get(this);
                    },
                    set: function (value) {
                        values_1.set(this, mapper(value));
                        this.forceUpdate();
                    },
                    enumerable: true,
                });
                this[key] = firstValue;
            },
            enumerable: true,
            configurable: true,
        });
    }
}
//# sourceMappingURL=index.js.map